<id>
Re-sort
</id>

<version>
1.0
</version>

<mod info>
Because of various moves, splices, and splits, the chronological order of individual posts within a thread can become mis-ordered: Older posts aren't always before the newer ones. This mod adds a "Re-sort" link (visible to admins) that allows you to re-order a thread so that all posts are in chronological order from oldest to newest.

In addition, you can also re-sort at the board level, to put posts that were placed at "the top of the list" (because they were moved, for example) in their proper chronological order.

Files modified:
  Sources/Subs.pl
  Sources/SubList.pl
  Sources/Display.pl
  Sources/MessageIndex.pl
  english.lng

Also, place 'resort.gif' in your YaBBimages directory.

Tested with YaBB 1 Gold - SP 1.3.1
</mod info>

<author>
Eddy
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Sources/Subs.pl
</edit file>

<search for>

1;
</search for>

<add before>
sub ResortThread {
    use Time::Local;

    my ($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate);
    my ($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $msf, $mfn);
    my (@oldorder, @neworder);
    my ($newlastposter, $newlastposttime);
    my ($views,$tmpa);
    my ($m,$d,$y,$h,$mn,$s,$dt);

    my $threadid = $INFO{'thread'};

    # Read thread
    fopen(FILE, "+<$datadir/$threadid.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
    seek FILE, 0, 0;
    my @messages = <FILE>;

    # Extract date from each post
    foreach (@messages) {
        ($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $msf, $mfn) = split(/\|/);
	($m,$d,$y,$h,$mn,$s) = ($mdate =~ m~(\d+)/(\d+)/(\d+) at (\d+):(\d+):(\d+)~);
	$dt = timelocal($s, $mn, $h, $d, $m - 1, $y);
        push (@oldorder, $dt);
    }

    # Sort posts by date from oldest to newest
    @neworder = @messages[ sort { $oldorder[$a] <=> $oldorder[$b] } 0..$#messages ];

    # Rewrite thread
    truncate FILE, 0;
    seek FILE, 0, 0;
    print FILE @neworder;
    fclose(FILE);

    # If the "last post" is now different after sorting, need to update stuff...
    if ($messages[$#messages] ne $neworder[$#neworder]) {
	# Extract info about last post
	$_ = $neworder[$#neworder];
	($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $msf, $mfn) = split(/\|/);
	$newlastposttime = $mdate;
	if ($musername ne "Guest") {
	    $newlastposter = $musername;
	} else {
	    $newlastposter = $mname;
	}

	# Update last poster in $threadid.data file
	fopen(FILE, "+<$datadir/$threadid.data", 1);
	seek FILE, 0, 0;
	$tmpa = <FILE>;
	($views,$tmpa) = split(/\|/, $tmpa);
	truncate FILE, 0;
	seek FILE, 0, 0;
	print FILE qq~$views|$newlastposter~;
	fclose(FILE);

	# Update last post date/time in $currentboard.txt file
	@oldorder = @neworder = ();
	fopen(FILE, "+<$boardsdir/$currentboard.txt", 1) || &write_error("211 $txt{'106'}: $txt{'23'} $currentboard.txt");
	    seek FILE, 0, 0;
	    my @buffer = <FILE>;
	    foreach (@buffer) {
		($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/);
		if ($mnum == $threadid) {
		    $mdate = $newlastposttime;
		    $_ = qq~$mnum|$msub|$mname|$memail|$mdate|$mreplies|$musername|$micon|$mstate~;
		}
		($m,$d,$y,$h,$mn,$s) = ($mdate =~ m~(\d+)/(\d+)/(\d+) at (\d+):(\d+):(\d+)~);
		$dt = timelocal($s, $mn, $h, $d, $m - 1, $y);
		push (@oldorder, $dt);
	    }

	    # Now re-sort board index by date from newest to oldest to ensure proper ordering
	    @neworder = @buffer[ sort { $oldorder[$b] <=> $oldorder[$a] } 0..$#buffer ];

	    # Rewrite new $currrentboard.txt order
	    truncate FILE, 0;
	    seek FILE, 0, 0;
	    print FILE @neworder;
	fclose(FILE);
    }

    $yySetLocation = qq~$cgi;action=display;num=$threadid~;
    &redirectexit;
}

sub ResortBoard {
    use Time::Local;

    my ($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate);
    my ($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $msf, $mfn);
    my (@oldorder, @neworder);
    my ($newlastposter, $newlastposttime);
    my ($views,$tmpa);
    my ($m,$d,$y,$h,$mn,$s);

    my $threadid = $INFO{'thread'};

    # Read board index
    fopen(FILE, "+<$boardsdir/$currentboard.txt") || &fatal_error("$txt{'23'} $currentboard.txt");
    seek FILE, 0, 0;
    my @messages = <FILE>;

    # Extract date from each post
    foreach (@messages) {
	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/);
	($m,$d,$y,$h,$mn,$s) = ($mdate =~ m~(\d+)/(\d+)/(\d+) at (\d+):(\d+):(\d+)~);
	$dt = timelocal($s, $mn, $h, $d, $m - 1, $y);
        push (@oldorder, $dt);
    }

    # Sort posts by date from newest to oldest
    @neworder = @messages[ sort { $oldorder[$b] <=> $oldorder[$a] } 0..$#messages ];

    # Rewrite the board index
    truncate FILE, 0;
    seek FILE, 0, 0;
    print FILE @neworder;
    fclose(FILE);

    $yySetLocation = qq~$cgi~;
    &redirectexit;
}

1;
</add before>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
%director=(
</search for>

<add after>
'resortthread',"Subs.pl&ResortThread",
'resortboard',"Subs.pl&ResortBoard",
</add after>

<edit file>
Sources/Display.pl
</edit file>

<search for>
        <a href="$cgi;action=sticky;thread=$viewnum">$img{'admin_sticky'}</a>
</search for>

<add after>
	<a href="$cgi;action=resortthread;thread=$viewnum">$img{'resort_thread'}</a>
</add after>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
  </tr>
</table><br>
</search for>

<replace>
  </tr>
</table>
~;

if (exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') {
  $yymain .= qq~
<table cellpadding=0 cellspacing=0 width="100%">
  <tr><td align="right"><a href="$cgi;action=resortboard">$img{'resort_board'}</a></td></tr>
<table>
~;
}

$yymain .= qq~
<br>
</replace>

<edit file>
english.lng
</edit file>

<search for>
$txt{'800'} = "Other";
</search for>

<add after>

$resort{'1'} = "Re-sort&nbsp;Thread";
$resort{'2'} = "Re-sort&nbsp;Board";
</add after>

<search for>
	$img{'website_sm'} = qq~<font size="1" class="imgwindowbg">$txt{'515'}</font>~;
</search for>

<add after>
	$img{'resort_thread'} = qq~<font size="1" class="imgbg">$resort{'1'}</font>~;
	$img{'resort_board'} = qq~<font size="1" class="imgbg">$resort{'2'}</font>~;
</add after>

<search for>
	$img{'website_sm'} = qq~<img src="$imagesdir/www.gif" alt="$txt{'515'}" border="0">~;
</search for>

<add after>
	$img{'resort_thread'} = qq~<img src="$imagesdir/resort.gif" border="0" alt="$resort{'1'}">&nbsp;<font size="1" class="imgbg">$resort{'1'}</font>~;
	$img{'resort_board'} = qq~<img src="$imagesdir/resort.gif" border="0" alt="$resort{'2'}">&nbsp;<font size="1" class="imgbg">$resort{'2'}</font>~;
</add after>
